﻿Public Interface IPlugin
    ReadOnly Property GameName() As String
    ReadOnly Property Name() As String
    ReadOnly Property ProcessName() As String
    ReadOnly Property Port() As String
    ReadOnly Property Is_MemoryMap() As Boolean
    ReadOnly Property Is_MemoryHook() As Boolean
    Sub Process_MemoryHook()
    Sub Process_MemoryMap()

    'run at start/stop
    Sub StartupCommands()
    Sub ShutDownCommands()

    'patching
    Function PatchGame(ByVal MyPath As String, ByVal MyIp As String) As Boolean
    Sub PatchPathInfo()
    Sub UnPatchGame(ByVal MyPath As String)
    Function ValidatePatchPath(ByVal MyPath As String) As Boolean

    'GameEngine - process info
    Sub Process_PacketRecieved(ByVal Text As String)

    'Game_Manager
    Function GetDOFsUsed() As String

    'output
    Function Get_RollOutput() As Double
    Function Get_PitchOutput() As Double
    Function Get_HeaveOutput() As Double
    Function Get_YawOutput() As Double
    Function Get_SwayOutput() As Double
    Function Get_SurgeOutput() As Double

    Function Get_RollMemHook() As Double
    Function Get_PitchMemHook() As Double
    Function Get_HeaveMemHook() As Double
    Function Get_YawMemHook() As Double
    Function Get_SwayMemHook() As Double
    Function Get_SurgeMemHook() As Double

    Function Get_RollMemMap() As Double
    Function Get_PitchMemMap() As Double
    Function Get_HeaveMemMap() As Double
    Function Get_YawMemMap() As Double
    Function Get_SwayMemMap() As Double
    Function Get_SurgeMemMap() As Double

    Sub ResetDOFVars()
    Sub ResetMapVars()
    Sub ResetHookVars()
End Interface
